#pragma warning (disable: 4786)

#include <deque>

#include "mapa_solve.h"

mapa_obs obsazeno;

struct polozka {
	polozka() {}
	polozka(unsigned char cx, unsigned char cy, signed char cvx, signed char cvy, signed char ccrashed) 
		: x(cx),y(cy),vx(cvx),vy(cvy),crashed(ccrashed) {}

	short x, y;
	signed char vx, vy, crashed;
};

char *mapa_solve(const mapa& m, trasa& t) {
	std::deque<polozka> fronta;
	fronta.push_back(polozka(m.sx,m.sy,0,0,0));
	obsazeno.at(m.sx,m.sy,0,0,0)=0xFF;

	polozka posledni;
	while (!fronta.empty()) {
		posledni=fronta.front(); fronta.pop_front();
		for (int ax=-1;ax<=1;ax++)
			for (int ay=-1;ay<=1;ay++) {
				polozka nova;
				nova.vx=posledni.vx+ax; nova.vy=posledni.vy+ay;
				nova.x=posledni.x+nova.vx; nova.y=posledni.y+nova.vy;
				nova.crashed=posledni.crashed;
				if (nova.x<0 || nova.x>=m.X || nova.y<0 || nova.y>=m.Y ||
					m.m[nova.x][nova.y]=='x'
#ifdef CRASH_DAMAGES
					|| (nova.crashed && (nova.vx<-MAX_VEL_AFTER_CRASH || nova.vx>MAX_VEL_AFTER_CRASH || nova.vy<-MAX_VEL_AFTER_CRASH || nova.vy>MAX_VEL_AFTER_CRASH))
#endif
					) {
					if (obsazeno.at(posledni.x,posledni.y,0,0,1)) continue;
					nova.x=posledni.x, nova.y=posledni.y;
					nova.vx=nova.vy=0; nova.crashed=1;
					obsazeno.ocollision[nova.x][nova.y]=VECTS_TO_ULONG(posledni.crashed,posledni.vx,posledni.vy);
				}
				unsigned char &c=obsazeno.at(nova.x,nova.y,nova.vx,nova.vy,nova.crashed);
				if (!c) { //jeste jsem tam nebyl
					c=((ax+2)<<2)+ay+2;
					if (m.m[nova.x][nova.y]=='c') { //found a way:)
						posledni=nova;				//remember the last one
						goto end;					//and jump out of 2 fors & 1 while
					}
					fronta.push_back(nova);
				}
			}
	}
end:
	if (m.m[posledni.x][posledni.y]!='c') return "Zadanou mapu nelze projet!";

	t.t.clear();
	unsigned char c;
	while (c=obsazeno.at(posledni.x,posledni.y,posledni.vx,posledni.vy,posledni.crashed),c!=0xFF) {
		int ax=(c>>2)-2,ay=(c&3)-2;
		t.push_front(ax,ay);
		if (posledni.vx==0 && posledni.vy==0 && posledni.crashed && obsazeno.ocollision[posledni.x][posledni.y]) {
			posledni.crashed=ULONG_TO_C(obsazeno.ocollision[posledni.x][posledni.y]);
			posledni.vx=ULONG_TO_VX(obsazeno.ocollision[posledni.x][posledni.y]);
			posledni.vy=ULONG_TO_VY(obsazeno.ocollision[posledni.x][posledni.y]);
		} else {
			posledni.x-=posledni.vx; posledni.y-=posledni.vy;
			posledni.vx-=ax; posledni.vy-=ay;
		}
	}
	return 0;
}
