#ifndef MAPA_SOLVE_BY_MILAN_STRAKA_2006
#define MAPA_SOLVE_BY_MILAN_STRAKA_2006
#pragma warning (disable: 4786)

#include <map>
#include "trasa.h"
#include "mapa.h"

char *mapa_solve(const mapa& m, trasa& t);

#define MAX_STORED_VECT 15		  //speed le to this is stored directly, bigger in std::map
#define abs(a) (((a) > 0) ? (a) : -(a))

#define MAX_VECT_SIZE 511           //maximum speed size for mixing in ULONG
#define VECTS_TO_ULONG(c,vx,vy) ( ((c)<<24) + (((vx)+MAX_VECT_SIZE)<<12) + (vy) + MAX_VECT_SIZE + 1 )
#define ULONG_TO_C(l) ( (l)>>24 )
#define ULONG_TO_VX(l) ( (((l)>>12)&0xFFF) - MAX_VECT_SIZE )
#define ULONG_TO_VY(l) (  ((l)     &0xFFF) - MAX_VECT_SIZE - 1 )

class mapa_obs {
public:
	unsigned char& at(unsigned short sx, unsigned short sy, signed char vx, signed char vy, signed char crashed);

	unsigned char o[MAX_MAPA_SIZE][MAX_MAPA_SIZE][2*MAX_STORED_VECT+1][2*MAX_STORED_VECT+1];
	unsigned char ocrashed[MAX_MAPA_SIZE][MAX_MAPA_SIZE][2*MAX_VEL_AFTER_CRASH+1][2*MAX_VEL_AFTER_CRASH+1];
	std::map<unsigned long,unsigned char> orest[MAX_MAPA_SIZE][MAX_MAPA_SIZE];
	unsigned long ocollision[MAX_MAPA_SIZE][MAX_MAPA_SIZE];
};

inline unsigned char& mapa_obs::at(unsigned short sx, unsigned short sy, signed char vx, signed char vy, signed char crashed) {
#ifdef CRASH_DAMAGES
	if (crashed) return ocrashed[sx][sy][vx][vy];
#endif
	if (abs(vx)<=MAX_STORED_VECT && abs(vy)<=MAX_STORED_VECT) return o[sx][sy][vx][vy];
	static unsigned char c; return c;
	return orest[sx][sy][VECTS_TO_ULONG(0,vx,vy)];
}

#endif
