// KunDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MapStatic.h"

/////////////////////////////////////////////////////////////////////////////
// CMapStatic message map


BEGIN_MESSAGE_MAP(CMapStatic, CWnd)
	ON_WM_PAINT()
	ON_WM_ERASEBKGND()
END_MESSAGE_MAP()

void CMapStatic::SetMapAndTrack(const mapa &m, const trasa &t) {
	m_X=m.X;
	m_Y=m.Y;
	CDC *pdc=GetDC();
	if (m_bmp) delete m_bmp;
	m_bmp=new CBitmap();
	m_bmp->CreateCompatibleBitmap(pdc,m_X,m_Y);
	ReleaseDC(pdc);

	CDC memdc;
	memdc.CreateCompatibleDC(NULL);
	CBitmap *bmpold=(CBitmap *)memdc.SelectObject(m_bmp);

	memdc.FillSolidRect(0,0,m_X,m_Y,RGB(0,0,0));
	for (int j=0;j<m_Y;j++)
		for (int i=0;i<m_X;i++) switch (m.m[i][j]) {
			case '.': memdc.SetPixel(i,j,RGB(0,128,0)); break;
			case ':': memdc.SetPixel(i,j,RGB(0,255,0)); break;
			case 's': memdc.SetPixel(i,j,RGB(0,255,255)); break;
			case 'c': memdc.SetPixel(i,j,RGB(255,0,255)); break;
		}

	int x=m.sx,y=m.sy,vx=0,vy=0;
	int t_len=t.t.size();
	bool crashed=false;
	for (int i=0;i<t_len;i++) {
		vx+=t.t[i].first; vy+=t.t[i].second;
		x+=vx; y+=vy;
		if (x<0 || x>=m_X || y<0 || y>=m_Y || m.m[x][y]=='x') {
			if (x>=0 && x<m_X && y>=0 && y<m_Y) memdc.SetPixel(x,y,RGB(0,0,255));
			x-=vx; y-=vy;
			vx=0; vy=0;
			memdc.SetPixel(x,y,RGB(255,0,0));
			crashed=true;
#ifdef CRASH_DAMAGES
		} else if (crashed && (vx<-MAX_VEL_AFTER_CRASH || vx>MAX_VEL_AFTER_CRASH || vy<-MAX_VEL_AFTER_CRASH || vy>MAX_VEL_AFTER_CRASH)) {
			x-=vx; y-=vy;
			vx=0; vy=0;
			memdc.SetPixel(x,y,RGB(255,0,0));
#endif
		} else switch(m.m[x][y]) {
			case '.': memdc.SetPixel(x,y,RGB(255,255,0)); break;
			case ':': memdc.SetPixel(x,y,RGB(208,255,0)); break;
			case 'c': memdc.SetPixel(x,y,RGB(255,128,255)); break;
		}
	}

	memdc.SelectObject(bmpold);
	Invalidate();
}

afx_msg void CMapStatic::OnPaint() {
	if (!m_bmp) {
		CPaintDC dc(this);CRect rc;GetClientRect(rc);dc.FillSolidRect(rc,RGB(255,255,255));
		return;
	}

	CPaintDC dc(this);
	CRect rc;
	GetClientRect(rc);
	
	dc.SetStretchBltMode(COLORONCOLOR);
	CDC memdc;
	memdc.CreateCompatibleDC(&dc);
	CBitmap *bmpold=(CBitmap *)memdc.SelectObject(m_bmp);
	dc.FillSolidRect(rc,RGB(0,0,0));
	if (m_Y * rc.Width() / m_X <= rc.Height()) {
		int h=m_Y * rc.Width() / m_X;
		dc.StretchBlt(0,(rc.Height()-h)/2,rc.Width(),h,&memdc,0,0,m_X,m_Y,SRCCOPY);
	} else {
		int w=m_X * rc.Height() / m_Y;
		dc.StretchBlt((rc.Width()-w)/2,0,w,rc.Height(),&memdc,0,0,m_X,m_Y,SRCCOPY);
	}
	memdc.SelectObject(bmpold);
};
