// showDlg.cpp : implementation file
//

#include "stdafx.h"
#include "show.h"
#include "showDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CShowDlg dialog

CShowDlg::CShowDlg(CWnd* pParent /*=NULL*/)
	: CMovableDialog(CShowDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CShowDlg)
	m_strMapName = _T("");
	m_strTrackName = _T("");
	m_bCheck = TRUE;
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CShowDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CShowDlg)
	DDX_Text(pDX, IDC_MAPNAME, m_strMapName);
	DDX_Text(pDX, IDC_TRACKNAME, m_strTrackName);
	DDX_Check(pDX, IDC_CHECKTRACK, m_bCheck);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CShowDlg, CDialog)
	//{{AFX_MSG_MAP(CShowDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	ON_BN_CLICKED(IDOK, OnOk)
	ON_BN_CLICKED(IDC_LOADMAP, OnLoadmap)
	ON_BN_CLICKED(IDC_LOADTRACK, OnLoadtrack)
	ON_BN_CLICKED(IDC_LEGEND, OnLegend)
	ON_BN_CLICKED(IDC_MAPA, OnMapaClick)
	//}}AFX_MSG_MAP
	ON_WM_GETMINMAXINFO()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CShowDlg message handlers

BOOL CShowDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_ctlMap.SubclassDlgItem(IDC_MAPA,this);

	// TODO: Add extra initialization here
	InitMovableDialog(IDC_MAPA,true);

	CString cline=AfxGetApp()->m_lpCmdLine,csecondpar;
	// try to split cline on space character
	int spacepos=cline.Find(' ');
	if (spacepos!=-1) {
		csecondpar=cline.Right(cline.GetLength() - spacepos - 1);
		csecondpar.TrimLeft();
		cline=cline.Left(spacepos);
	}

	m_strMapName=cline;
	m_strTrackName=csecondpar;
	char cwd[MAX_PATH+1];
	GetCurrentDirectory(MAX_PATH,cwd);
	if (cline.GetLength() && cline.Find(':')==-1) cline=cwd+CString("\\")+cline;
	if (csecondpar.GetLength() && csecondpar.Find(':')==-1) csecondpar=cwd+CString("\\")+csecondpar;
	m_strMapPath=cline;
	m_strTrackPath=csecondpar;
	UpdateData(FALSE);

	UpdateLoadPossible();
	if (m_bLoadPossible) OnOk();

	m_dlgLegend=new CLegendDlg(this);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

BOOL CShowDlg::DestroyWindow() 
{
	if (m_dlgLegend) {
		m_dlgLegend->DestroyWindow();
		delete m_dlgLegend;
	}
	m_dlgLegend=NULL;
	
	return CDialog::DestroyWindow();
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CShowDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CShowDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CShowDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	ApplyMovableDialog(cx,cy);	
}

void CShowDlg::OnGetMinMaxInfo(MINMAXINFO* lpMMI)
{
	CDialog::OnGetMinMaxInfo(lpMMI);

	CWnd *w;
	if (!(w=GetDlgItem(IDC_CONTROLS))) return;

	CRect rcControls;
	w->GetClientRect(rcControls);	
	lpMMI->ptMinTrackSize.x=rcControls.Width()+28;
	lpMMI->ptMinTrackSize.y=rcControls.Height()+GetSystemMetrics(SM_CYMENU)+GetSystemMetrics(SM_CYCAPTION);
}

void CShowDlg::OnOk() 
{
	UpdateData(TRUE);

	char *ret;
	
	if (ret=m.load(m_strMapPath),ret!=0) {
		MessageBox(ret,"Chyba pi natn mapy!",MB_OK | MB_ICONSTOP);
		return;
	}

	if (ret=t.load(m_strTrackPath),ret!=0) {
		MessageBox(ret,"Chyba pi natn trasy!",MB_OK | MB_ICONSTOP);
		return;
	}

	//should I do a check?
	if (m_bCheck) {
		if (ret=m.check_trasa(t),ret!=0) {
			MessageBox(ret,"Dan trasa neprojede mapu!",MB_OK | MB_ICONSTOP);
			return;
		}
	}

	m_ctlMap.SetMapAndTrack(m,t);
	Invalidate();
}

void CShowDlg::OnCancel() 
{
	CDialog::OnCancel();
}

void CShowDlg::OnLoadmap() 
{
	UpdateData(TRUE);
	CFileDialog dlg(TRUE,"txt",m_strMapPath,OFN_HIDEREADONLY|OFN_EXPLORER|OFN_FILEMUSTEXIST|OFN_NOCHANGEDIR|OFN_PATHMUSTEXIST,"Textov soubory (*.txt)|*.txt|Vechny soubory (*.*)|*.*|",this);	
	if (dlg.DoModal()==IDOK) {
		m_strMapName=dlg.GetFileName();
		m_strMapPath=dlg.GetPathName();
		UpdateData(FALSE);
		UpdateLoadPossible();
	}
}

void CShowDlg::OnLoadtrack() 
{
	UpdateData(TRUE);
	CFileDialog dlg(TRUE,"txt",m_strTrackPath,OFN_HIDEREADONLY|OFN_EXPLORER|OFN_FILEMUSTEXIST|OFN_NOCHANGEDIR|OFN_PATHMUSTEXIST,"Textov soubory (*.txt)|*.txt|Vechny soubory (*.*)|*.*|",this);	
	if (dlg.DoModal()==IDOK) {
		m_strTrackName=dlg.GetFileName();
		m_strTrackPath=dlg.GetPathName();
		UpdateData(FALSE);
		UpdateLoadPossible();
	}	
}

void CShowDlg::UpdateLoadPossible()
{
	CFileStatus status;
	if (m_strMapPath.GetLength()==0 || !CFile::GetStatus(m_strMapPath,status)) goto fail;
	if (m_strTrackPath.GetLength()==0 || !CFile::GetStatus(m_strTrackPath,status)) goto fail;
	m_bLoadPossible=true;
	GetDlgItem(IDOK)->EnableWindow(true);
	return;
fail:
	m_bLoadPossible=false;
	GetDlgItem(IDOK)->EnableWindow(false);
}

void CShowDlg::OnLegend() 
{
	if (m_dlgLegend) m_dlgLegend->ShowWindow(SW_SHOW);
}

void CShowDlg::OnMapaClick() 
{
	OnLegend();	
}
